package eu.mhsl.craftattack.worldmuseum.commands;

import net.minestom.server.command.builder.Command;
import net.minestom.server.command.builder.arguments.ArgumentEnum;
import net.minestom.server.command.builder.arguments.ArgumentType;
import net.minestom.server.entity.GameMode;
import net.minestom.server.entity.Player;

public class GamemodeCommand extends Command {
    public GamemodeCommand() {
        super("gamemode");
        addSyntax(
                (sender, context) -> {
                    ((Player) sender).setGameMode(((PlayerGameModes) context.get("target")).getGameMode());
                    ((Player) sender).setAllowFlying(true);
                }, ArgumentType.Enum("target", PlayerGameModes.class).setFormat(ArgumentEnum.Format.LOWER_CASED)
        );
    }

    public enum PlayerGameModes {
        SURVIVAL(GameMode.SURVIVAL),
        SPECTATOR(GameMode.SPECTATOR),
        ADVENTURE(GameMode.ADVENTURE);

        final GameMode gameMode;
        PlayerGameModes(GameMode gameMode) {
            this.gameMode = gameMode;
        }

        public GameMode getGameMode() {
            return gameMode;
        }
    }
}


