package eu.mhsl.craftattack.worldmuseum.commands;

import net.minestom.server.command.builder.Command;
import net.minestom.server.command.builder.arguments.ArgumentType;
import net.minestom.server.entity.Player;

import java.util.Objects;

public class TeleportCommand extends Command {

    public TeleportCommand() {
        super("tp","teleport");

        var playerArgument = ArgumentType.Entity("Spieler").onlyPlayers(true);

        addSyntax(((sender, context) -> {
            Player targetPlayer = (Player) context.get(playerArgument).find(sender).get(0);
            Player p = (Player) sender;
            if (!Objects.equals(p.getInstance(), targetPlayer.getInstance()))
                p.setInstance(Objects.requireNonNull(targetPlayer.getInstance()), targetPlayer.getPosition());
            else
                p.teleport(targetPlayer.getPosition());
        }), playerArgument);

    }
}
