package eu.mhsl.craftattack.worldmuseum.listener;

import eu.mhsl.craftattack.worldmuseum.items.BedManager;
import eu.mhsl.craftattack.worldmuseum.util.NewPlayer;
import eu.mhsl.craftattack.worldmuseum.items.CompassManager;
import eu.mhsl.craftattack.worldmuseum.worlds.World;
import net.kyori.adventure.text.Component;
import net.minestom.server.event.player.PlayerUseItemEvent;
import net.minestom.server.item.ItemStack;
import java.util.function.Consumer;

public class ItemUseListener implements Consumer<PlayerUseItemEvent> {

    @Override
    public void accept(PlayerUseItemEvent playerUseItemEvent) {
        NewPlayer p = (NewPlayer) playerUseItemEvent.getPlayer();
        ItemStack usedItem = playerUseItemEvent.getItemStack();
        CompassManager compassManager = CompassManager.getInstance();

        if (usedItem.equals(compassManager.getCompass())) compassUse(p);
        else if (usedItem.equals(BedManager.getBedItem())) bedUse(p);

        playerUseItemEvent.setCancelled(true);
    }
    private void compassUse(NewPlayer p) {
        CompassManager compassManager = CompassManager.getInstance();
        if (!p.isAllowCompassUsage()) {
            long lastUsed = (System.currentTimeMillis() - p.getLastCompassUsage()) / 1000;
            p.sendActionBar(Component.text("Du kannst den Kompass erst in " + (15 - lastUsed) + " Sekunden wieder benutzen."));
            return;
        }
        p.openInventory(compassManager.getInventory());
    }
    private void bedUse(NewPlayer player) {
        World world = (World) player.getInstance();
        assert world != null;
        player.teleport(world.getSpawn());
    }
}
