package eu.mhsl.craftattack.worldmuseum.util;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import eu.mhsl.craftattack.worldmuseum.worlds.World;
import eu.mhsl.craftattack.worldmuseum.worlds.WorldManager;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;

public class Config {
    private static Config instance;
    private World start_world;
    public static Config getInstance() {
        if (instance == null) instance = new Config();
        return instance;
    }
    public void loadConfig() {
        checkConfig();
        try {
            JsonObject config = (JsonObject) JsonParser.parseReader(new FileReader("config.json"));
            Iterator iterator =  WorldManager.getInstance().getWorlds().iterator();
            while (iterator.hasNext()) {
                World w = (World) iterator.next();
                if (!w.getName().equals(config.get("start_world").getAsString())) continue;
                this.start_world = w;
            }
            if (start_world == null) {
                System.out.println("no starting world set");
                System.exit(0);
            }

        }catch (IOException e) {
            e.printStackTrace();
        }
    }
    private String default_config = "{\n" +
            "  \"start_world\": \"world\"\n" +
            "}";

    private void checkConfig() {
        try {
            File checkfile = new File("./config.json");
            if (checkfile.createNewFile()) {
                FileWriter fileWriter = new FileWriter("config.json");
                fileWriter.write(default_config);
                fileWriter.close();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public World getStart_world() {
        return start_world;
    }
}
