package eu.mhsl.craftattack.worldmuseum.util;

import net.minestom.server.entity.Player;
import net.minestom.server.network.player.PlayerConnection;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.time.Duration;
import java.util.UUID;

public class NewPlayer extends Player {

    private boolean allowMovement = true;
    private long lastCompassUsage = 0;
    private boolean allowCompassUsage = true;

    public NewPlayer(@NotNull UUID uuid, @NotNull String username, @NotNull PlayerConnection playerConnection) {
        super(uuid, username, playerConnection);
    }
    public void setSyncCooldown(@Nullable Duration cooldown) {
        this.setCustomSynchronizationCooldown(cooldown);
    }

    public boolean isAllowMovement() {
        return allowMovement;
    }
    public void update_lastCompassUsage() {
        lastCompassUsage = System.currentTimeMillis();
    }
    public boolean isAllowCompassUsage() {
        long UsageDifference = System.currentTimeMillis() - lastCompassUsage;
        long difference = 15000; //in Milisec
        return UsageDifference >= difference && allowCompassUsage;
    }

    public void setAllowMovement(boolean allowMovement) {
        this.allowMovement = allowMovement;
    }
    public void setAllowCompassUsage(boolean allowCompassUsage) {
        this.allowCompassUsage = allowCompassUsage;
    }
    public long getLastCompassUsage() {
        return lastCompassUsage;
    }

}
